<?php
// $Id: index.php,v 1.10 2002/03/16 10:58:52 jgm Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Author: Mike Welch
// Based on Template Modlue by Jim McDonald
// Purpose of file:  Reco user display functions
// ----------------------------------------------------------------------
if (!defined("LOADED_AS_MODULE"))
{
    die ("You can't access this file directly...");
}

modules_get_language();
$module=true;
$ModName = basename( dirname( __FILE__ ) );
$output=new pnHTML();
$output->StartPage();
$output->SetInputMode(_PNH_VERBATIMINPUT);
$output->Text(reco_user_main());
$output->EndPage();
$output->PrintPage();

/**
 * the main user function
 */
function reco_user_main()
{

    // Create output object - this object will store all of our output so that
    // we can return it easily when required
    $output = new pnHTML();

    // Security check - important to do this as early as possible to avoid
    // potential security holes or just too much wasted processing.  For the
    // main function we want to check that the user has at least overview
    // privilege for some item within this component, or else they won't be
    // able to see anything and so we refuse access altogether.  The lowest
    // level of access for administration depends on the particular module, but
    // it is generally either 'overview' or 'read'
    if (!pnSecAuthAction(0, 'Reco::Item', 'Reco::', ACCESS_READ)) {
        $output->Text("Not authorised to access Recommendations modules");
        return $output->GetOutput();
    }
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Title("Recommendations");
    $output->Text(reco_user_view());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Return the output that has been generated by this function
    return $output->GetOutput();
}

/**
 * view items
 */
function reco_user_view()
{

    // Create output object - this object will store all of our output so that
    // we can return it easily when required
    $output = new pnHTML();

    // Security check - important to do this as early as possible to avoid
    // potential security holes or just too much wasted processing
    if (!pnSecAuthAction(0, 'Reco::Item', 'Reco::', ACCESS_OVERVIEW)) {
        $output->Text(_RECONOAUTH);
        return $output->GetOutput();
    }

    // Load API.  All of the actual work for obtaining information on the items
    // is done within the API, so we need to load that in before we can do
    // anything.  If the API fails to load an appropriate error message is
    // posted and the function returns
    if (!pnModAPILoad('Reco', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // The API function is called.  The arguments to the function are passed in
    // as their own arguments array
    $cats = pnModAPIFunc('Reco',
                          'user',
                          'getallcats',
                          array('startnum' => 0,
                                'numitems' => 100));

    // The return value of the function is checked here, and if the function
    // suceeded then an appropriate message is posted.  Note that if the
    // function did not succeed then the API function should have already
    // posted a failure message so no action is required
    if ($cats == false) {
        $output->Text(_RECOCATFAILED);
    }

    // Loop through each item and display it.  Note the use of pnVarCensor() to
    // remove any words from the name that the administrator has deemed
    // unsuitable for the site

	$columnsonpage=pnModGetVar('Reco','columnsonpage');
    foreach ($cats as $cat) {
        
	if (pnSecAuthAction(0,
                            'Reco::Item',
                            "$cat[name]::$cat[id]",
                            ACCESS_READ)) {
    
	    // Get the items int the cat
	    $itemsx = pnModAPIFunc('Reco',
                          'user',
                          'getallitems',
                          array('startnum' => 0,
                                'numitems' => 100,
                                'getcat'=>$cat[id]));
	    if ($itemsx != false) {
		
	  		$output->SetOutputMode(_PNH_KEEPOUTPUT);
    	   	$output->TableStart($cat[name]);
  
    	   	$row=array();
    	   	$rowcount=0;
    	   	foreach ($itemsx as $itemx) {
    	   	    
        
		    if (pnSecAuthAction(0,
                            'Reco::',
                            "$temx[name]::$itemx[id]",
                            ACCESS_READ)) {
            
    		    	if ($rowcount == $columnsonpage) {
    		    	    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    		    	    $output->TableAddRow($row);
    		    	    $row=array();
    		    	    
    		    	    $rowcount=0;
    		    	} 
    		   	    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    		   	    $output->SetInputMode(_PNH_VERBATIMINPUT);
						
					$itemtxt='';
					if ($itemx[imgsrc]!='') {
						$itemtxt=$itemtxt . '<IMG SRC="' . $itemx[imgsrc] . '"><BR>';
					}
					$itemtxt=$itemtxt .  $itemx[desc1] . '<BR>' . $itemx[desc2] . '<BR>';
					if ($itemx[buyurl]!='') {
						$itemtxt=$itemtxt . '<A HREF="' . $itemx[buyurl] . '">' . pnModGetVar('Reco','clickheretxt') . '</a>';
					}

					$row[] = $output->Text($itemtxt);
	 	    	    $rowcount++;

    	   
    	   	    }
    	   	   
    	   	}
    	   	$output->SetOutputMode(_PNH_KEEPOUTPUT);
    		$output->TableAddRow($row);
    	   	$output->SetOutputMode(_PNH_KEEPOUTPUT);
    	   	$output->TableEnd();  	    	   	
    	   
	    }
	      
            $output->SetInputMode(_PNH_PARSEINPUT);
            $output->Linebreak();
    	}
    }

	$output->SetInputMode(_PNH_VERBATIMINPUT);
	$output->Text(pnModGetVar('Reco','pagetrailer'));

    
    // Return the output that has been generated by this function
    return $output->GetOutput();
}

?>
