<?php
// $Id: latestitems.php,v 1.3 2002/02/09 12:56:31 jgm Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Author: Mike Welch
// Based on Template Modlue by Jim McDonald
// Purpose of file:  Reco 'Latest Items' block
// ----------------------------------------------------------------------

/**
 * initialise block
 */
function reco_latestitemsblock_init()
{
    // Security
    pnSecAddSchema('Reco:LatestItems:', 'Block title::');
}

/**
 * get information on block
 */
function reco_latestitemsblock_info()
{
    // Values
    return array('text_type' => 'Latest Items',
                 'module' => 'Reco',
                 'text_type_long' => 'Show latest recommendations',
                 'allow_multiple' => true,
                 'form_content' => false,
                 'form_refresh' => false,
                 'show_preview' => true);
}

/**
 * display block
 */
function reco_latestitemsblock_display($blockinfo)
{
    // Security check
    if (!pnSecAuthAction(0,
                         'Reco:LatestItems:',
                         "$blockinfo[title]::",
                         ACCESS_READ)) {
        return;
    }

    // Get variables from content block
    $vars = pnBlockVarsFromContent($blockinfo['content']);

    // Database information
    pnModDBInfoLoad('Reco');
    list($dbconn) = pnDBGetConn();
    $pntable =pnDBGetTables();
    $recocattable = $pntable['recocategory'];
    $recocatcolumn = &$pntable['recocategory_column'];

    // Query
    $sql = "SELECT $recocatcolumn[id],
                   $recocatcolumn[category]
            FROM $recocattable
            ORDER by $recocatcolumn[category]";
    $result = $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        return;
    }

    if ($result->EOF) {
        return;
    }

    // Create output object
    $output = new pnHTML();

    // Display each item, permissions permitting
    for (; !$result->EOF; $result->MoveNext()) {
        list($tid, $name) = $result->fields;


		//Get latest item in category
    	$recoitemtable = $pntable['recoitem'];
	    $recoitemcolumn = &$pntable['recoitem_column'];

		// Query
		$sql = "SELECT $recoitemcolumn[desc1],
			$recoitemcolumn[desc2],
			$recoitemcolumn[imgsrc],
			$recoitemcolumn[buyurl]
		    FROM $recoitemtable
			WHERE $recoitemcolumn[category] = $tid
			ORDER by $recoitemcolumn[id] desc 
			LIMIT 1";
	   	$itemresult = $dbconn->Execute($sql);

       	if ($dbconn->ErrorNo() != 0) {
			return;
		}

		if (!$itemresult->EOF) {

			list($desc1, $desc2, $imgsrc, $buyurl) = $itemresult->fields;
        
			$output->Title($name);

			$output->SetInputMode(_PNH_VERBATIMINPUT);

			$itemtxt='<center>';
			if ($imgsrc!='') {
				$itemtxt=$itemtxt . '<IMG SRC="' . $imgsrc . '"><BR>';
			}
		    $itemtxt=$itemtxt .  $desc1 . '<BR>' . $desc2 . '<BR>';
		    if ($buyurl!='') {
				$itemtxt=$itemtxt . '<A HREF="' . $buyurl . '">' . pnModGetVar('Reco','clickheretxt') . '</a>';
			}

			$itemtxt=$itemtxt . '</center>';
			$output->Text($itemtxt);
			
			$output->Linebreak();
		}
	}
	$output->Text(pnModGetVar('Reco','blocktrailer'));
	$linktxt='<P><center><A HREF="modules.php?op=modload&name=Reco&file=index">' . _RECOMORERECO . '</a></center>';
	$output->Text($linktxt);
        


    
    // Populate block info and pass to theme
    $blockinfo['content'] = $output->GetOutput();
    return themesideblock($blockinfo);
}


/**
 * modify block settings
 */
function reco_latestitemsblock_modify($blockinfo)
{
   $output = new pnHTML();
   return $output->GetOutput();
}

/**
 * update block settings
 */
function reco_latestitemsblock_update($blockinfo)
{
    return $blockinfo;
}

?>
